	list      p=16f628a
	#include <p16f628a.inc>
	
	__CONFIG _CP_OFF & _WDT_OFF & _BODEN_ON & _PWRTE_ON & _INTRC_OSC_NOCLKOUT & _MCLRE_OFF & _LVP_OFF

w_temp		EQU	0x70 
status_temp	EQU	0x71
CNT1		EQU	0x20
CNT2		EQU	0x21
TMP_DATA	EQU	0x22
TMP_DATA_B	EQU	0x23 ; busy`FbNp
TMP_CNT		EQU	0x24
CCNT		EQU	0x25 ; JE^
LCNT		EQU	0x26 ; sԍtO
TMP_CHR		EQU	0x27

;Symbols For LCD
#define	LCD_DATA	PORTA
#define	LCD_DDIR	TRISA
#define	LCD_RS		PORTB,5
#define	LCD_RW		PORTB,6
#define	LCD_E		PORTB,7
#define	BUSY_BIT	3	;{͏4bit

#define	ROWS		d'16' ; 16
;**********************************************************************
		ORG     0x000
		goto    main

		ORG		0x004
		movwf		w_temp
		movf		STATUS,w
		movwf		status_temp

; ISR Codes

		movf		status_temp,w
		movwf		STATUS
		swapf		w_temp,f
		swapf		w_temp,w
		retfie

main
		bcf		STATUS,RP0
		bcf		STATUS,RP1 ; oN0ɐݒ

		clrf		INTCON ; 荞݂֎~
		clrf		PORTA  ; PORTA
		movlw		0x07
		movwf		CMCON  ; Rp[^gpȂ

		bsf		STATUS,RP0 ; oN1ɐݒ

		bsf		PCON,OSCF ; NbN4MHz
		movlw		B'00011111'
		movwf		TRISB     ; PORTB̏o̓rbgݒ
		clrf		LCD_DDIR  ; LCDf[^|[go͂

		movlw		d'25'
		movwf		SPBRG	  ; {[[gWFl[^25Zbg
		movlw		b'00000100'; BRGH=19600bps
		movwf		TXSTA	  ; BRGH=1Zbg

		bcf		STATUS,RP0; oN0ɖ߂

		movlw		b'10010000' ; Mݒ
		movwf		RCSTA	; SPEN,SREN=1

		bcf		LCD_RS    ;
		bcf		LCD_RW    ; LCD̐M[
		bcf		LCD_E     ;
		clrf		LCD_DATA  ;
	
main_init
		call		dly_10m   ; Ô10mS҂
		call		lcd_init  ; LCD
		call		dly_10m

		movlw		b'00001110' ;J[\ItAE֕\
		call		cmd_send
		call		dly_10m
		clrf		CCNT      ; LN^JE^Zbg
		clrf		LCNT      ; stOZbg

		clrf		TMP_CNT   ; e|JE^NA
str_out1
		movf		TMP_CNT,w ;o
		call		INIT_MSG
		addlw		0x00      ;[ȂI
		btfsc		STATUS,Z
		goto		msg_out
		call		chr_out
		incf		TMP_CNT,f
		goto		str_out1

msg_out
		movlw		d'100'
		movwf		TMP_CNT  ;bZ[W1b\
msg_loop
		call		dly_10m  
		decfsz		TMP_CNT,f;bZ[W\x
		goto		msg_loop

		call		disp_clr ;\NA

rcv_loop
		btfss		PIR1,RCIF ; 1byteM܂ő҂
		goto		rcv_loop
		movf		RCREG,w   ;Mf[^荞
		movwf		TMP_CHR   ;ꎞۑ
		sublw		0x0c		;CTRL-L`FbN
		btfss		STATUS,Z
		goto		chr_chk2
		call		disp_clr ;CTRL-LȂ\NA
		goto		rcv_loop
chr_chk2
		movf		TMP_CHR,w
		sublw		0x0d		;[CR]H
		btfss		STATUS,Z
		goto		chr_put
		call		line_chg ;[CR]Ȃs
		goto		rcv_loop
chr_put
		movf		TMP_CHR,w  ;`FbN̈ȊOȂo
		call		chr_out
rcv_ext
		bcf		RCSTA,FERR ;t[~OG[tOZbg
		bcf		RCSTA,OERR ;I[oG[tOZbg
		goto		rcv_loop

;\NA
disp_clr
		movlw		b'00000001'
		call		cmd_send ; \NA
		clrf		CCNT
		clrf		LCNT
		return

; 1o
; wɕ\Zbg
chr_out
		call		data_send
		incf		CCNT,f ;o͂+1
		movlw		ROWS
		subwf		CCNT,w ;ROWSƓɂȂ
		btfss		STATUS,Z
		goto		chr_done ; ROWSƓł͂Ȃ̂ŏI
line_chg
		clrf		CCNT  ;JE^Zbg
		btfss		LCNT,0 ; ݂1sڂH
		goto		chr_ld1
		movlw		b'10000000';1sڂɃAhXZbg
		call		cmd_send
		bcf		LCNT,0
		goto		chr_done
chr_ld1					; 2sڂɃAhXZbg
		movlw		b'11000000'
		call		cmd_send
		bsf		LCNT,0
chr_done
		return

INIT_MSG
		addwf		PCL,1
		DT	"MIRS1105        System START !",0x00	

; LCD
; 4bit[h
lcd_init
		call		dly_10m
		call		dly_10m
		movlw		b'00110000' ;f[^1 
		call		cmd_send4
		call		dly_10m
		movlw		b'00110000' ;f[^2
		call		cmd_send4
		call		dly_100u
		movlw		b'00110000' ;f[^3
		call		cmd_send4
		call		dly_100u
		movlw		b'00100000' ;4bit[hɃZbg
		call		cmd_send4
		call		dly_100u
		call		busy_check

		movlw		b'00101000' ;[hݒ
		call		cmd_send

		movlw		b'00000001' ;LCDNA
		call		cmd_send

		movlw		b'00000110' ;Gg[hZbg
		call		cmd_send

		return

; LCDɃR}h𑗏o
; wWX^=R}h
; FWX^: TMP_DATA
cmd_send	; CMD=w
		movwf		TMP_DATA
		swapf		TMP_DATA,w
		andlw		0x0f
		movwf		LCD_DATA
		bcf		LCD_RW
		bcf		LCD_RS
		bsf		LCD_E ; NbN4MHzȂȄグ
		bcf		LCD_E ; 1uŜŏ\
		movf		TMP_DATA,w
		andlw		0x0f
		movwf		LCD_DATA
		bcf		LCD_RW
		bcf		LCD_RS
		bsf		LCD_E
		bcf		LCD_E
		call		busy_check

		return

; p4bitR}ho
; wWX^=R}h(4bit)
; FWX^ : TMP_DATA
; rW[`FbNłȂԗp
cmd_send4
		movwf		TMP_DATA
		swapf		TMP_DATA,w
		andlw		0x0f
		movwf		LCD_DATA
		bcf		LCD_RW
		bcf		LCD_RS
		bsf		LCD_E ; NbN4MHzȂȄグ
		bcf		LCD_E ; 1uŜŏ\

		return


; LCDɃf[^𑗏o
; wWX^=f[^
; FWX^: TMP_DATA
data_send
		movwf		TMP_DATA
		swapf		TMP_DATA,w
		andlw		0x0f
		movwf		LCD_DATA
		bcf		LCD_RW
		bsf		LCD_RS
		bsf		LCD_E ; NbN4MHzȂȄグ
		bcf		LCD_E ; 1uŜŏ\
		movf		TMP_DATA,w
		andlw		0x0f
		movwf		LCD_DATA
		bcf		LCD_RW
		bsf		LCD_RS
		bsf		LCD_E
		bcf		LCD_E
		call		busy_check

		return

; LCDrW[`FbN
; FWX^:TMP_DATA_B
busy_check
		bsf		STATUS,RP0 ; bank=1
		movlw		0xff
		movwf		LCD_DDIR
		bcf		STATUS,RP0 ; bank=0
busy_chk1
		bcf		LCD_RS
		bsf		LCD_RW
		bsf		LCD_E
		nop
		movf		LCD_DATA,w
		andlw		0x0f
		movwf		TMP_DATA_B
		bcf		LCD_E
		nop
		bsf		LCD_E
		nop			  ; 4rbg͖
		bcf		LCD_E
		btfsc		TMP_DATA_B,BUSY_BIT
		goto		busy_chk1
		bcf		LCD_RW
		bsf		STATUS,RP0 ; bank=1
		movlw		0x00
		movwf		LCD_DDIR
		bcf		STATUS,RP0 ; bank=0
		return

;Ԓx[` NbN4MHzp

; 100}CNbx
; FWX^: CNT1
dly_100u	; 100uS
		movlw		0x32
		movwf		CNT1
dly_100u1
		decfsz		CNT1,f
		goto		dly_100u1
		return

; 10~bx
; FWX^:CNT1
dly_10m	; 10mS
		movlw		0x0a
		movwf		CNT1
dly_10m1
		call		dly_1m
		decfsz		CNT1,f
		goto		dly_10m1
		return

; 1~bx
; FWX^:CNT2
dly_1m	; 1ms
		movlw		0xf8
		movwf		CNT2
dly_1m1
		nop
		nop
		decfsz		CNT2,f
		goto		dly_1m1
		return

		END
